> For a complete documentation index, fetch https://docs.voximplant.ai/llms.txt

# CreateSipRegistration

POST https://api.voximplant.com/platform_api/CreateSipRegistration

Creates a new SIP registration (the platform registers as a user on a 3rd party SIP server).

There are two modes of SIP registration:

<ol><li>Persistent registration, when the platform registers on a 3rd party SIP server as a user and the registration lasts until deleted (or there are network/technical issues with it — see the corresponding callback)</li><li>Non-persistent registration (set `is_persistent` to false) which is initiated only when the specificed user (with `user_id` or `user_name`) logs in via one of Voximplant SDKs. As soon the user logs off, the registration goes offline. This mode helps to implement SIP softphone-like apps using Voximplant’s SDKs.</li></ol>

Please note that when you create a SIP registration, we reserve the subscription fee and taxes for the upcoming month. Read more in the <a href='/docs/gettingstarted/billing'>Billing</a> page.

Allowed roles: `Owner`, `Admin`, `Accountant`.

**Example request:** Create SIP registration.

Reference: https://docs.voximplant.ai/api-reference/management-api/reference/sip-registration/create-sip-registration

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: management-api
  version: 1.0.0
paths:
  /CreateSipRegistration:
    post:
      operationId: create-sip-registration
      summary: CreateSipRegistration
      description: >-
        Creates a new SIP registration (the platform registers as a user on a
        3rd party SIP server).


        There are two modes of SIP registration:


        <ol><li>Persistent registration, when the platform registers on a 3rd
        party SIP server as a user and the registration lasts until deleted (or
        there are network/technical issues with it — see the corresponding
        callback)</li><li>Non-persistent registration (set `is_persistent` to
        false) which is initiated only when the specificed user (with `user_id`
        or `user_name`) logs in via one of Voximplant SDKs. As soon the user
        logs off, the registration goes offline. This mode helps to implement
        SIP softphone-like apps using Voximplant’s SDKs.</li></ol>


        Please note that when you create a SIP registration, we reserve the
        subscription fee and taxes for the upcoming month. Read more in the <a
        href='/docs/gettingstarted/billing'>Billing</a> page.


        Allowed roles: `Owner`, `Admin`, `Accountant`.


        **Example request:** Create SIP registration.
      tags:
        - subpackage_sipRegistration
      parameters:
        - name: sip_username
          in: query
          description: The user name
          required: true
          schema:
            type: string
        - name: proxy
          in: query
          description: The SIP proxy
          required: true
          schema:
            type: string
        - name: auth_user
          in: query
          description: The SIP authentications user
          required: false
          schema:
            type: string
        - name: outbound_proxy
          in: query
          description: The outgoing SIP proxy
          required: false
          schema:
            type: string
        - name: password
          in: query
          description: The SIP password
          required: false
          schema:
            type: string
        - name: is_persistent
          in: query
          description: >-
            Whether SIP registration is persistent. Set false to activate it
            only on the user login
          required: false
          schema:
            type: boolean
            default: true
        - name: application_id
          in: query
          description: >-
            The application ID which a new SIP registration is to be bound to.
            Can be used instead of the **application_name** parameter
          required: false
          schema:
            type: integer
        - name: application_name
          in: query
          description: >-
            The application name which a new SIP registration is to be bound to.
            Can be used instead of the **application_id** parameter
          required: false
          schema:
            type: string
        - name: rule_id
          in: query
          description: >-
            The rule ID which a new SIP registration is to be bound to. Can be
            used instead of the **rule_name** parameter
          required: false
          schema:
            type: integer
        - name: rule_name
          in: query
          description: >-
            The rule name which a new SIP registration is to be bound to. Can be
            used instead of the **rule_id** parameter
          required: false
          schema:
            type: string
        - name: user_id
          in: query
          description: >-
            The user ID which a new SIP registration is to be bound to. Can be
            used instead of the **user_name** parameter
          required: false
          schema:
            type: integer
        - name: user_name
          in: query
          description: >-
            The user name which a new SIP registration is to be bound to. Can be
            used instead of the **user_id** parameter
          required: false
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            Voximplant Management API uses signed JWT tokens generated from your
            service-account private key. Pass the token in the `Authorization`
            header as a Bearer value:


            ```

            Authorization: Bearer $VOXIMPLANT_TOKEN

            ```


            See [Authorization](/api-reference/management-api/authorization) for
            ready-to-copy snippets in bash, Python, Node.js and Go that turn
            your `credentials.json` into a token.
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/sip-registration_CreateSipRegistration_Response_200
servers:
  - url: https://api.voximplant.com/platform_api
components:
  schemas:
    ShortAccountInfoType:
      type: object
      properties:
        account_id:
          type: integer
          description: The account's ID
        frozen:
          type: boolean
          description: Whether account is blocked by Voximplant admins or not
        balance:
          type: number
          format: double
          description: The account's money
        currency:
          type: string
          description: The currency code (USD, RUR, EUR, ...)
      description: The short account info.
      title: ShortAccountInfoType
    CreateSipRegistrationPostResponsesContentApplicationJsonSchemaErrorDetails:
      type: object
      properties:
        required_money:
          type: number
          format: double
      title: >-
        CreateSipRegistrationPostResponsesContentApplicationJsonSchemaErrorDetails
    CreateSipRegistrationPostResponsesContentApplicationJsonSchemaError:
      type: object
      properties:
        msg:
          type: string
        code:
          type: integer
        details:
          $ref: >-
            #/components/schemas/CreateSipRegistrationPostResponsesContentApplicationJsonSchemaErrorDetails
      title: CreateSipRegistrationPostResponsesContentApplicationJsonSchemaError
    sip-registration_CreateSipRegistration_Response_200:
      type: object
      properties:
        result:
          type: integer
          description: Returns 1 if the request has been completed successfully
        sip_registration_id:
          type: integer
          description: The sip registration id
        account_info:
          $ref: '#/components/schemas/ShortAccountInfoType'
          description: The current account state
        error:
          $ref: >-
            #/components/schemas/CreateSipRegistrationPostResponsesContentApplicationJsonSchemaError
      title: sip-registration_CreateSipRegistration_Response_200
  securitySchemes:
    JwtAuth:
      type: http
      scheme: bearer
      description: >-
        Voximplant Management API uses signed JWT tokens generated from your
        service-account private key. Pass the token in the `Authorization`
        header as a Bearer value:


        ```

        Authorization: Bearer $VOXIMPLANT_TOKEN

        ```


        See [Authorization](/api-reference/management-api/authorization) for
        ready-to-copy snippets in bash, Python, Node.js and Go that turn your
        `credentials.json` into a token.

```

## SDK Code Examples

```python Success
import requests

url = "https://api.voximplant.com/platform_api/CreateSipRegistration"

querystring = {"sip_username":"john.doe","proxy":"sip.example.com","auth_user":"john.doe","outbound_proxy":"outbound.sip.example.com","password":"SecurePass123!","is_persistent":"true","application_id":"4567","rule_id":"7890","user_id":"12345"}

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, params=querystring)

print(response.json())
```

```javascript Success
const url = 'https://api.voximplant.com/platform_api/CreateSipRegistration?sip_username=john.doe&proxy=sip.example.com&auth_user=john.doe&outbound_proxy=outbound.sip.example.com&password=SecurePass123%21&is_persistent=true&application_id=4567&rule_id=7890&user_id=12345';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Success
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.voximplant.com/platform_api/CreateSipRegistration?sip_username=john.doe&proxy=sip.example.com&auth_user=john.doe&outbound_proxy=outbound.sip.example.com&password=SecurePass123%21&is_persistent=true&application_id=4567&rule_id=7890&user_id=12345"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Success
require 'uri'
require 'net/http'

url = URI("https://api.voximplant.com/platform_api/CreateSipRegistration?sip_username=john.doe&proxy=sip.example.com&auth_user=john.doe&outbound_proxy=outbound.sip.example.com&password=SecurePass123%21&is_persistent=true&application_id=4567&rule_id=7890&user_id=12345")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java Success
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.voximplant.com/platform_api/CreateSipRegistration?sip_username=john.doe&proxy=sip.example.com&auth_user=john.doe&outbound_proxy=outbound.sip.example.com&password=SecurePass123%21&is_persistent=true&application_id=4567&rule_id=7890&user_id=12345")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php Success
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.voximplant.com/platform_api/CreateSipRegistration?sip_username=john.doe&proxy=sip.example.com&auth_user=john.doe&outbound_proxy=outbound.sip.example.com&password=SecurePass123%21&is_persistent=true&application_id=4567&rule_id=7890&user_id=12345', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Success
using RestSharp;

var client = new RestClient("https://api.voximplant.com/platform_api/CreateSipRegistration?sip_username=john.doe&proxy=sip.example.com&auth_user=john.doe&outbound_proxy=outbound.sip.example.com&password=SecurePass123%21&is_persistent=true&application_id=4567&rule_id=7890&user_id=12345");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Success
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.voximplant.com/platform_api/CreateSipRegistration?sip_username=john.doe&proxy=sip.example.com&auth_user=john.doe&outbound_proxy=outbound.sip.example.com&password=SecurePass123%21&is_persistent=true&application_id=4567&rule_id=7890&user_id=12345")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

```python Insufficient money to add a new SIP registration
import requests

url = "https://api.voximplant.com/platform_api/CreateSipRegistration"

querystring = {"sip_username":"john.doe","proxy":"sip.example.com","auth_user":"john.doe","outbound_proxy":"outbound.sip.example.com","password":"SecurePass123!","is_persistent":"true","application_id":"4567","rule_id":"7890","user_id":"12345"}

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, params=querystring)

print(response.json())
```

```javascript Insufficient money to add a new SIP registration
const url = 'https://api.voximplant.com/platform_api/CreateSipRegistration?sip_username=john.doe&proxy=sip.example.com&auth_user=john.doe&outbound_proxy=outbound.sip.example.com&password=SecurePass123%21&is_persistent=true&application_id=4567&rule_id=7890&user_id=12345';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Insufficient money to add a new SIP registration
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.voximplant.com/platform_api/CreateSipRegistration?sip_username=john.doe&proxy=sip.example.com&auth_user=john.doe&outbound_proxy=outbound.sip.example.com&password=SecurePass123%21&is_persistent=true&application_id=4567&rule_id=7890&user_id=12345"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Insufficient money to add a new SIP registration
require 'uri'
require 'net/http'

url = URI("https://api.voximplant.com/platform_api/CreateSipRegistration?sip_username=john.doe&proxy=sip.example.com&auth_user=john.doe&outbound_proxy=outbound.sip.example.com&password=SecurePass123%21&is_persistent=true&application_id=4567&rule_id=7890&user_id=12345")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java Insufficient money to add a new SIP registration
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.voximplant.com/platform_api/CreateSipRegistration?sip_username=john.doe&proxy=sip.example.com&auth_user=john.doe&outbound_proxy=outbound.sip.example.com&password=SecurePass123%21&is_persistent=true&application_id=4567&rule_id=7890&user_id=12345")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php Insufficient money to add a new SIP registration
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.voximplant.com/platform_api/CreateSipRegistration?sip_username=john.doe&proxy=sip.example.com&auth_user=john.doe&outbound_proxy=outbound.sip.example.com&password=SecurePass123%21&is_persistent=true&application_id=4567&rule_id=7890&user_id=12345', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Insufficient money to add a new SIP registration
using RestSharp;

var client = new RestClient("https://api.voximplant.com/platform_api/CreateSipRegistration?sip_username=john.doe&proxy=sip.example.com&auth_user=john.doe&outbound_proxy=outbound.sip.example.com&password=SecurePass123%21&is_persistent=true&application_id=4567&rule_id=7890&user_id=12345");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Insufficient money to add a new SIP registration
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.voximplant.com/platform_api/CreateSipRegistration?sip_username=john.doe&proxy=sip.example.com&auth_user=john.doe&outbound_proxy=outbound.sip.example.com&password=SecurePass123%21&is_persistent=true&application_id=4567&rule_id=7890&user_id=12345")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```